#include "Slider.H"

#include "Logger.H"
extern Logger logger;

Slider::Slider(unsigned int wdth, unsigned int hght, int min, int max):
		_changed(true),
		_width(wdth),
		_height(hght),
		_min(min),
		_max(max),
		_cur(min) {
	_grd=new Grid(_width,_height);
}

Slider::~Slider() {
	delete(_grd);
}

widstat Slider::input(Char inp) {
	unsigned int
		range=(_max-_min)+1,
		ratio=range/(_width-2),
		offset=(_min<0)?(0-_min):0,
		loc=(_cur+offset)/ratio;
	if ((inp.isLeftArrow()) && (loc))
		loc--;
	else if ((inp.isRightArrow()) && (loc < (_width-2)))
		loc++;
	else
		return (ws_rejected);
	_cur=_min+(loc*ratio);
	logger.log("current position is now %d",_cur);
	_changed=true;
	return (ws_accepted);
}

const Grid &Slider::draw() {
	Char c=_stile;
	unsigned int
		sli=(_height/2),
		range=(_max-_min)+1,
		ratio=range/(_width-2),
		offset=(_min<0)?(0-_min):0,
		loc=(_cur+offset)/ratio;
	c='|';
	for (unsigned int y=0; y < _height; y++) {
		(*_grd).set(0,y,c);
		(*_grd).set(_width-1,y,c);
	}
	c='-';
	for (unsigned int x=1; x < _width-1; x++) {
		(*_grd).set(x,sli,c);;
	}
	c=_tstile;
	c='[';
	(*_grd).set(loc,sli,c);
	c=']';
	(*_grd).set(loc+1,sli,c);
	_changed=false;
	return (*_grd);
}
